﻿@{
    Layout = "~/_SiteLayout.cshtml";
    Page.Title = "Weddings";

    var email = "";
    try {
        email = Session["username"].ToString();
    } catch {
        Context.RedirectLocal("~/Account/Login");
    }
    string title = "";

    var db = Database.Open("webdev");
    var weddings = db.Query("SELECT Code, Title FROM Weddings WHERE LOWER(Owner) = LOWER(@0)", email);

    bool hasWeddings = false;
    string Weddingtext = "You have not yet planned any weddings.";
    foreach(var w in weddings) {
        hasWeddings =  true;        
        Weddingtext = "These are your weddings:";
        break; //if there are any weddings already planned
    }

    var stars = db.Query("SELECT w.Code, w.Title FROM Weddings as w, Stars as s WHERE LOWER(s.Email) = LOWER(@0) AND s.Wedding_ID = w.id ", email);
    
    bool hasStars = false;
    string Starredtext = "You have not yet starred any weddings.";
    foreach(var s in stars) {
        hasStars =  true;        
        Starredtext = "These are your starred weddings:";
        break; //if there are any weddings already planned
    }

    Validation.RequireField("title", "You must specify a title. Perhaps the date?");

    // If this is a POST request, validate and process data
    if (IsPost) {
//        AntiForgery.Validate();

        if (Validation.IsValid()) {
            title = Request.Form["title"];

            var codeTMP = new char[8];
            var random = new Random();

            for (int i = 0; i < 8; i++) {
                codeTMP[i] = "ABCDEFGHIJKLMNOPQRSTUVWXYZ0123456789"[random.Next(36)];
            }
            string code = new String(codeTMP);

            db.Query("INSERT INTO Weddings (Owner, Code, Title) VALUES (@0, @1, @2)", email, code, title );
            Context.RedirectLocal("~/Weddings");
        }
    }
}

<hgroup class="title">
    <h1>Plan your @Page.Title!</h1>
</hgroup>

<h3>Your current weddings!</h3>
@Weddingtext
@if(hasWeddings) {
    <table>
    @foreach(var w in weddings){
        <tr><td><a href="~/gifts.cshtml/@w.Code">@w.Title</a></td></tr>
    }
    </table>
}

<h3>Your starred weddings!</h3>
@Starredtext
@if(hasStars) {
    <table>
    @foreach(var s in stars){
        <tr><td><a href="~/gifts.cshtml?code=@s["Code"]">@s["Title"]</a></td></tr>
    }
    </table>
}

<h3>Plan a new wedding!</h3>
<form method="post">
     <fieldset>
        <ol>
            <li class="title">
                <label for="title" @if (!ModelState.IsValidField("title")) {<text>class="error-label"</text>}>Wedding title</label>
                <input type="text" id="title" name="title" value="@title" @Validation.For("title")/>
                @* Write any user name validation errors to the page *@
                @Html.ValidationMessage("title")
            </li>
        </ol>
        <input type="submit" value="Plan" />
    </fieldset>
</form>


